﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PropertyGrid
{
    public class ViewModel
    {
        public IParent Parent

        {
            get;
            set;
        }       
    
    }

    public class Parent : IParent
{
     public Parent(string name, IChild child)
    {
        this.ParentName = name;
        this.Child = child;
    }

 public   string ParentName { get; set; }

   public IChild Child { get; set; }

        string IParent.ParentName
        {
            get
            {
                return ParentName;
            }

            set
            {
                ParentName = value;
            }
        }

        IChild IParent.Child
        {
            get
            {
                return Child;
            }

            set
            {
                Child = value;
            }
        }
    }



public interface IChild
    {
        string Id { get; set; }
        string Name { get; set; }
    }

    public interface IParent

    {

        string ParentName { get; set; }

        IChild Child { get; set; }

    }



    public class Child : IChild
    {
        public Child(string id, string name)
        {
            _id = id;
            _name = name;
        }

        private string _id;
        public string Id
        {
            get { return _id; }
            set { _id = value; }
        }

        private string _name;
        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }

        public override string ToString()
        {
            return _id + " :: " + _name;
        }
    }
}